// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <stdlib.h>
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>

#include "OGL.h"

// konstruktor *************************************************************
COGL::COGL()
{
 rot_x=1.0f; rot_y=1.0f;
}

// destruktor **************************************************************
COGL::~COGL()
{

}

// inicializacia OpenGL - nastavenie parametrov pre tvorbu OpenGL sceny ****
bool COGL::gl_initialize(void)
{
 // definicia premennych ***************************************************
 for (t_a=0;t_a<8;t_a++) { // nastavenie 8-mich vseobecnych materialov
  ogl_material[t_a].amb[0]=0.2f; ogl_material[t_a].amb[1]=0.2f;
  ogl_material[t_a].amb[2]=0.2f; ogl_material[t_a].amb[3]=1.0f;
  ogl_material[t_a].dif[0]=0.8f; ogl_material[t_a].dif[1]=0.8f;
  ogl_material[t_a].dif[2]=0.8f; ogl_material[t_a].dif[3]=1.0f;
  ogl_material[t_a].spe[0]=0.0f; ogl_material[t_a].spe[1]=0.0f;
  ogl_material[t_a].spe[2]=0.0f; ogl_material[t_a].spe[3]=1.0f;
  ogl_material[t_a].amb_dif[0]=0.2f; ogl_material[t_a].amb_dif[1]=0.2f;
  ogl_material[t_a].amb_dif[2]=0.2f; ogl_material[t_a].amb_dif[3]=1.0f;
  ogl_material[t_a].emi[0]=0.0f; ogl_material[t_a].emi[1]=0.0f;
  ogl_material[t_a].emi[2]=0.0f; ogl_material[t_a].emi[3]=1.0f;
  ogl_material[t_a].shi=0.0f;
  ogl_material[t_a].transp=0.0f;
  ogl_material[t_a].sillum[0]=0.0f; ogl_material[t_a].sillum[1]=0.0f;
  ogl_material[t_a].sillum[2]=0.0f; ogl_material[t_a].sillum[3]=1.0f;
 }

 for (t_a=0;t_a<8;t_a++) { // nastavenie 8-mich vseobecnych svetiel
  ogl_light[t_a].amb[0]=0.5f; ogl_light[t_a].amb[1]=0.5f;
  ogl_light[t_a].amb[2]=0.5f; ogl_light[t_a].amb[3]=1.0f;
  ogl_light[t_a].dif[0]=0.75f; ogl_light[t_a].dif[1]=0.75f;
  ogl_light[t_a].dif[2]=0.75f; ogl_light[t_a].dif[3]=1.0f;
  ogl_light[t_a].spe[0]=1.0f; ogl_light[t_a].spe[1]=1.0f;
  ogl_light[t_a].spe[2]=1.0f; ogl_light[t_a].spe[3]=1.0f;
  ogl_light[t_a].pos[0]=0.0f; ogl_light[t_a].pos[1]=10.0f;
  ogl_light[t_a].pos[2]=0.0f; ogl_light[t_a].pos[3]=1.0f;
  ogl_light[t_a].spot[0]=0.0f;
  ogl_light[t_a].spot[1]=0.0f;
  ogl_light[t_a].spot[2]=-1.0f;
 }

 // nastavenie OpenGL renderovacich parametrov *****************************
 glClearColor(0.0f,0.0f,0.0f,0.5f); // zasobnik farieb bude vymazavany ciernou farbou
 glClearDepth(1.0f);                // zasobnik hlbky bude vymazavany nastavenim na 1.0
 // nastavenie parametrov 1 svetla
 glLightfv(GL_LIGHT0,GL_AMBIENT,ogl_light[0].amb);
 glLightfv(GL_LIGHT0,GL_DIFFUSE,ogl_light[0].dif);
 glLightfv(GL_LIGHT0,GL_SPECULAR,ogl_light[0].spe);
 // zapnutie/vypnutie osvetlenia
 ogl_lighting=0;
 if (ogl_lighting==1) glEnable(GL_LIGHTING);
 else glDisable(GL_LIGHTING);
 //glEnable(GL_LIGHT0);

 glDepthFunc(GL_LEQUAL);            // typ porovnavacej funkcie pre urcenie z-vzdialenosti
 glEnable(GL_DEPTH_TEST);           // zapnutie testovania hlbky

 glDisable(GL_CULL_FACE);           // nastavenie poradia, v ktorom budu definovane body objektu
 glFrontFace(GL_CCW);               // reprezentovat privratene resp. odvratene plochy,
 glCullFace(GL_BACK);
 glEnable(GL_CULL_FACE);            // odvratene plochy sa nebudu spracovavat
                                    // vseobecny material objektov
 glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,ogl_light[0].dif);
                                    // svetelne vypocty su lokalne
 glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE);
 glShadeModel(GL_SMOOTH);           // zapnutie gourand-jemneho tienovania
                                    // osvetlenie textur alias modulate
 //glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
                                    // realnejsie perspektivne vypocty a korekcie
 glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

 ogl_fogColor[0]=0.0f; ogl_fogColor[1]=0.0f;
 ogl_fogColor[2]=0.0f; ogl_fogColor[3]=1.0f;
 glFogi(GL_FOG_MODE,GL_EXP);             // typ hmly
 glFogfv(GL_FOG_COLOR,ogl_fogColor);     // farba hmly
 glFogf(GL_FOG_DENSITY,0.01f);            // hustota hmly
 glHint(GL_FOG_HINT,GL_DONT_CARE);       // dalsie nastavenia
 glFogf(GL_FOG_START,256.0f);            // pociatok viditelnosti hmly
 glFogf(GL_FOG_END,512.0f);              // vzdialenost max. hmly
 glEnable(GL_FOG);									// povolenie hmly

 //glEnableClientState(GL_VERTEX_ARRAY);
 //glEnableClientState(GL_NORMAL_ARRAY);

 //glEnable(GL_LINE_SMOOTH);          // antialiasing ciar alias smoothline
 //glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);
                                    // funkcia pre vypocet priesvitnosti
 //glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
 //glEnable(GL_BLEND);              // zapnutie vypoctu priesvitnosti
 //glLineWidth(1.5);

 //glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

 // inicializacia vypisovania OpenGL textu
 if (ogl_text.text_initialize()) return(1);

 // nahratie textur
 if (ogl_texture.LoadTexture("data/earth.bmp")) {
  fprintf(stderr,"Chyba nahratia textur!\n");
  return(1);
 }

 ogl_object.obj_quad=gluNewQuadric();               //ukazovatel na kvadratik objekt
 gluQuadricNormals(ogl_object.obj_quad,GLU_SMOOTH); // smooth normaly
 gluQuadricTexture(ogl_object.obj_quad,GL_TRUE);    // vytvorenie koordinatov textur

 // inicializacia skybox
 if (ogl_object.obj_skybox_init("skybox")) {
  fprintf(stderr,"Chyba inicializacie skybox!\n");
  return(1);
 }

 return(0);
}

// vykreslenie OpenGL sceny ************************************************
GLubyte COGL::gl_draw(void)
{
 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

 // zresetovanie modelovej matice
 glLoadIdentity();

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 glMultMatrixf(ogl_camera[0].matrix);

 ogl_object.obj_skybox_draw();

 glTranslatef(ogl_camera[0].posx,ogl_camera[0].posy,ogl_camera[0].posz);

 // ulozenie aktualnej matice do zasobnika matic
 glPushMatrix();

 // transformacia objektov sceny
 //glScalef(10.0f,1.0f,10.0f);
 //glTranslatef(0.0f,-10.0f,0.0f);

 //ogl_object.obj_XZplane1(0.5f);

 glPopMatrix();
 glPushMatrix();

 glPushAttrib(GL_TEXTURE_BIT);
 glEnable(GL_TEXTURE_2D);

 // pouzitie textury pre pokrytie objektu
 glBindTexture(GL_TEXTURE_2D,ogl_texture.texture_id[0]);

 // transformacia objektov sceny
 //glTranslatef(5.0f,0.0f,0.0f);
 glRotatef(90.0f,1.0f,0.0f,0.0f);
 glRotatef(10.0f,0.0f,1.0f,0.0f);
 glRotatef(-rot_x,0.0f,0.0f,1.0f);

 // definicia objektu-kocky
 //gluCylinder(ogl_object.obj_quad,1.0f,1.0f,3.0f,30,1);
 gluSphere(ogl_object.obj_quad,5.0f,32,32);

 glPopAttrib();
 glPopMatrix();

 rot_x+=0.5f; rot_y+=0.5f;

 // vypis textu - poloha kamery
 sprintf(ogl_text.mybuf,"x: %6.2f",-ogl_camera[0].posx);
 ogl_text.DrawString(10.0f,30.0f);
 sprintf(ogl_text.mybuf,"y: %6.2f",-ogl_camera[0].posy);
 ogl_text.DrawString(10.0f,20.0f);
 sprintf(ogl_text.mybuf,"z: %6.2f",-ogl_camera[0].posz);
 ogl_text.DrawString(10.0f,10.0f);

 // vypis textu - pocet obrazkov za sekundu
 sprintf(ogl_text.mybuf,"%i fps",(GLuint) ogl_camera[0].ogl_fps);
 ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-20.0f);

 // vypis textu - hmla
 glGetIntegerv(GL_FOG_MODE,&ogl_state[0]);
 if (ogl_state[0]==GL_EXP) sprintf(ogl_text.mybuf,"hmla: exp");
 else if (ogl_state[0]==GL_EXP2) sprintf(ogl_text.mybuf,"hmla: exp2");
      else sprintf(ogl_text.mybuf,"hmla: linear");
 ogl_text.DrawString(ogl_camera[0].scr_w-190.0f,ogl_camera[0].scr_h-20.0f);
 // vypis textu - material
 glGetIntegerv(GL_POLYGON_MODE,&ogl_state[0]);
 if (ogl_state[0]==GL_LINE) sprintf(ogl_text.mybuf,"material: ciary");
 else sprintf(ogl_text.mybuf,"material: vypln");
 ogl_text.DrawString(ogl_camera[0].scr_w-190.0f,ogl_camera[0].scr_h-40.0f);

 return(0);
}

// zmena sposobu zobrazenia objektov ***************************************
void COGL::change_PolygonMode(void)
{
 glGetIntegerv(GL_POLYGON_MODE,&ogl_state[0]);

 // vypis nacitaneho stavu
 //fprintf(stderr,"%d\n",ogl_state[0]);

 if (ogl_state[0]==GL_LINE) glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
 else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
}

// zmena parametrov hmly ***************************************************
void COGL::change_FogMode(void)
{
 glGetIntegerv(GL_FOG_MODE,&ogl_state[0]);

 // vypis nacitaneho stavu
 //fprintf(stderr,"%d\n",ogl_state[0]);

 if (ogl_state[0]==GL_EXP) glFogi(GL_FOG_MODE,GL_EXP2);
 else if (ogl_state[0]==GL_EXP2) glFogi(GL_FOG_MODE,GL_LINEAR);
      else glFogi(GL_FOG_MODE,GL_EXP);
}
